# ------------------------------------------------------------
# ask_for_readme()
# ------------------------------------------------------------

ask_for_readme() {
if [ -n "$INFO_DIR" -a -f $INFO_DIR/[Rr][Ee][Aa][Dd][Mm][Ee].[Tt][Xx][Tt] ]; then
    UPSMANREADME=`ls $INFO_DIR/[Rr][Ee][Aa][Dd][Mm][Ee].[Tt][Xx][Tt] 2>/dev/null`

    $doecho \\nDo you want to read the information for UPSMAN software [Y/n]?: \\c
    read yesno
    dodebug "yesno = >$yesno<"
    if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
#    if [ "$yesno" = "" -o $yesno = y -o $yesno = Y ]; then
	more $UPSMANREADME; sleep 1
    fi
fi
}

# ------------------------------------------------------------
# do_upsman_inst()
# ------------------------------------------------------------

do_upsman_inst() {
if [ -n "$WPATH" -a -d $WPATH/[Uu][Pp][Ss] ]; then
    UPS=`ls -d $WPATH/[Uu][Pp][Ss] 2>/dev/null`
else
    doerror can\'t find "$WPATH"/UPS, no such directory!
fi
[ -f $UPS/*.[Tt][Aa][Rr] ] || doerror can\'t find $UPS/*.tar, no such file!

UPSMAN_TAR=`ls $UPS/*.[Tt][Aa][Rr] 2>/dev/null`

$doecho \\nInstall UPS daemon and tools in `pwd`... \\c

tarerror=`$UNTAR $UPSMAN_TAR 2>&1`
#[ "$tarerror" ] && doerror \\n$tarerror

chown root:0 upsman && chmod 770 upsman
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/upsman
chown root:0 upsmon && chmod 770 upsmon
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/upsmon
chown root:0 upstcp && chmod 770 upstcp
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/upstcp
chown root:0 ups_conf && chmod 770 ups_conf
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/ups_conf

if [ -f rccmd ]; then
chown root:0 rccmd && chmod 770 rccmd
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/rccmd
fi

if [ -f upscgi ]; then
chown root:0 upscgi && chmod 775 upscgi
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/upscgi
fi

[ -f upspopup ] && chown root:0 upspopup && chmod 700 upspopup

$doecho ok!; sleep 1

}

# ------------------------------------------------------------
# do_upsexe_inst()
# ------------------------------------------------------------

do_upsexe_inst() {
if [ -d $WPATH/[Uu][Pp][Ss][Ee][Xx][Ee] ]; then
    UPSEXE=`ls -d $WPATH/[Uu][Pp][Ss][Ee][Xx][Ee] 2>/dev/null`
else
    doerror can\'t find $WPATH/UPSEXE, no such directory!
fi
if [ -f $UPSEXE/[Uu][Pp][Ss][Ee][Xx][Ee].[Tt][Aa][Rr] ]; then
    UPSEXETAR=`ls $UPSEXE/[Uu][Pp][Ss][Ee][Xx][Ee].[Tt][Aa][Rr] 2>/dev/null`
else
    doerror can\'t find $UPSEXE/upsexe.tar, no such file!
fi

$doecho \\nInstall default command scripts to `pwd`/*.sh... \\c

tarerror=`$UNTAR $UPSEXETAR 2>&1`
#[ "$tarerror" ] && doerror \\n$tarerror

chown root:0 alarm.sh && chmod 770 alarm.sh
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/alarm.sh
chown root:0 message.sh && chmod 770 message.sh
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/message.sh
chown root:0 upssend.sh && chmod 770 upssend.sh
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/upssend.sh

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# do_upstyp_inst()
# ------------------------------------------------------------

do_upstyp_inst() {
if [ -d $VER/[Vv][Ee][Nn][Dd][Oo][Rr][Ss] ]; then
    VENDOR=`ls -d $VER/[Vv][Ee][Nn][Dd][Oo][Rr][Ss] 2>/dev/null`
else
    doerror can\'t find $VER/VENDORS, no such directory!
fi
if [ -d $VENDOR/$D ]; then
    LANGDIR=$VENDOR/$D
else
    doerror can\'t find $VENDORS/$D, no such directory!
fi
# check if language allready choosen
if [ -n "$UPSLANG" -a -d $LANGDIR/$UPSLANG ]; then
    UPSTYP=`ls $LANGDIR/$UPSLANG/[Uu][Pp][Ss][Tt][Yy][Pp].[Uu][Pp][Ss] 2>/dev/null`
elif [ -d $LANGDIR/[Ee][Nn][Gg][Ll][Ii][Ss][Hh] ]; then
    UPSTYP_LANG_DIR=`ls -d $LANGDIR/[Ee][Nn][Gg][Ll][Ii][Ss][Hh] 2>/dev/null`
    if [ -f $UPSTYP_LANG_DIR/[Uu][Pp][Ss][Tt][Yy][Pp].[Uu][Pp][Ss] ]; then
        UPSTYP=`ls $UPSTYP_LANG_DIR/[Uu][Pp][Ss][Tt][Yy][Pp].[Uu][Pp][Ss] 2>/dev/null`
    fi
fi

if [ ! -f "$UPSTYP" ]; then
# ChooseLanguage reads $PRG, $LANGDIR sets $UPSLANG
    ChooseLanguage
    if [ -d $LANGDIR/$UPSLANG ]; then
        UPSTYP_LANG_DIR=$LANGDIR/$UPSLANG
    else
        doerror can\'t find $LANGDIR/$UPSLANG, no such directory!
    fi
    if [ -f $UPSTYP_LANG_DIR/[Uu][Pp][Ss][Tt][Yy][Pp].[Uu][Pp][Ss] ]; then
        UPSTYP=`ls $UPSTYP_LANG_DIR/[Uu][Pp][Ss][Tt][Yy][Pp].[Uu][Pp][Ss] 2>/dev/null`
    else
        doerror can\'t find $UPSTYP_LANG_DIR/upstyp.ups, no such file!
    fi
fi

$doecho \\nInstall UPS database to `pwd`/upstyp.ups... \\c

cp $UPSTYP ./upstyp.ups || doerror failed to copy $UPSTYP

chown root:0 upstyp.ups && chmod 660 upstyp.ups
[ $? = 0 ] || doerror failed to fix permissions for `pwd`/upstyp.ups

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# WriteStartupsman()
# ------------------------------------------------------------

WriteStartupsman() {

[ -z "$UPSMAN_STARTER" ] && UPSMAN_STARTER=startupsman

if [ -f $UPSMAN_STARTER ]; then
    $doecho \\nsave existing `pwd`/$UPSMAN_STARTER to `pwd`/${UPSMAN_STARTER}.bkp... \\c
    mv $UPSMAN_STARTER ${UPSMAN_STARTER}.bkp || doerror \\nfailed to rename $UPSMAN_STARTER
    $doecho ok!; sleep 1
fi

$doecho \\nwriting startscript `pwd`/${UPSMAN_STARTER}... \\c

cat > $UPSMAN_STARTER<<EOF
#!/bin/sh
#

[ -x `pwd`/upsman ] || exit 0

export UPSAGT_AGENTX="no"
export UPSAGT_PORT=1161

PATH=/sbin:/usr/sbin:/bin:/usr/bin

case "\$1" in
start)
    cd ${UPS_DIR}
    upsmanpid=\`$ps_prog | awk '\$4 ~ /upsman/ && \$4 !~ /[0-9]/ && \$2 ~ /[?|-]/ { print \$1 }'\`
    [ -z "\${upsmanpid}" ] && ./upsman && ./upstcp
    if [ -x ./upshttpd ]; then
	upshttpdpid=\`$ps_prog | awk '\$4 ~ /upshttpd/ { print \$1 }'\`
	[ -z "\${upshttpdpid}" ] && ./upshttpd >/dev/null 2>&1
    fi
    if [ -x ./upsagent ]; then
	upsagentpid=\`$ps_prog | awk '\$4 ~ /upsagent/ { print \$1 }'\`
	[ -z "\${upsagentpid}" ] && ./upsagent
    fi
    ;;

stop)
    cd ${UPS_DIR}
    upsmanpid=\`$ps_prog | awk '\$4 ~ /upsman/ && \$4 !~ /[0-9]/ && \$2 ~ /[?|-]/ { print \$1 }'\`
    [ -x ./upshttpd ] && upshttpdpid=\`$ps_prog | awk '\$4 ~ /upshttpd/ { print \$1 }'\`
    [ -x ./upsagent ] && upsagentpid=\`$ps_prog | awk '\$4 ~ /upsagent/ { print \$1 }'\`
    [ -n "\${upsmanpid}" ] && ./upsman -s
    [ -n "\${upshttpdpid}" ] && kill \${upshttpdpid}
    [ -n "\${upsagentpid}" ] && kill \${upsagentpid}
    ;;
*)
    echo "Usage: \$0 start|stop"; exit 1 
    ;;
esac
exit 0
EOF

[ $? = 0 ] && chown root:0 $UPSMAN_STARTER && chmod 774 $UPSMAN_STARTER
[ $? = 0 ] || doerror failed to write $UPSMAN_STARTER

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# WriteStartupsmanSuSE() - v9.3 needs more LSB conformance.
# ------------------------------------------------------------
WriteStartupsmanSuSE() {

[ -z "$UPSMAN_STARTER" ] && UPSMAN_STARTER=startupsman

if [ -f $UPSMAN_STARTER ]; then
    $doecho \\nsave existing `pwd`/$UPSMAN_STARTER to `pwd`/${UPSMAN_STARTER}.bkp... \\c
    mv $UPSMAN_STARTER ${UPSMAN_STARTER}.bkp || doerror \\nfailed to rename $UPSMAN_STARTER
    $doecho ok!; sleep 1
fi

$doecho \\nwriting startscript `pwd`/${UPSMAN_STARTER}... \\c

cat > $UPSMAN_STARTER<<EOF
#!/bin/sh
#
# System startup script for UPSManager service/daemon
#
# /etc/init.d/upsman 
#
### BEGIN INIT INFO
# Provides:       upsman
# Required-Start: $local_fs $network $named $syslog
# Should-Start:
# Required-Stop:
# Default-Start:   2 3 5
# Default-Stop:    0 1 5
# Description:    Start the UPS Manager service
### END INIT INFO

# Check for missing binaries
UPSMAN_BIN=/usr/ups/upsman
test -x \$UPSMAN_BIN || { echo "\$UPSMAN_BIN not installed"; 
	if [ "\$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

UPSTCP_BIN=/usr/ups/upstcp
test -x \$UPSTCP_BIN || { echo "\$UPSTCP_BIN not installed"; 
	if [ "\$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# Check for needed config file
UPSMAN_CONFIG=/usr/ups/ups.cfg
test -r \$UPSMAN_CONFIG || { echo "\$UPSMAN_CONFIG not existing";
	if [ "\$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

# Load the rc.status script.
. /etc/rc.status

# Reset status.
rc_reset

# Set our environment
export UPSAGT_AGENTX="no"
export UPSAGT_PORT=1161

PATH=/sbin:/usr/sbin:/bin:/usr/bin

case "\$1" in
   start)
      echo -n "Starting UPSMAN service..."
      cd ${UPS_DIR}
	   \$UPSMAN_BIN 
      \$UPSTCP_BIN > /dev/null 2>&1
		if [ -x ./upshttpd ]; then
	      upshttpdpid=\`$ps_prog | awk '\$4 ~ /upshttpd/ { print \$1 }'\`
	      [ -z "\${upshttpdpid}" ] && ./upshttpd >/dev/null 2>&1
      fi
      if [ -x ./upsagent ]; then
	      upsagentpid=\`$ps_prog | awk '\$4 ~ /upsagent/ { print \$1 }'\`
	      [ -z "\${upsagentpid}" ] && ./upsagent
      fi
	   rc_status -v
	   ;;
   stop)
      echo -n "Stopping UPSMAN service..."
      cd ${UPS_DIR}
      [ -x ./upshttpd ] && upshttpdpid=\`$ps_prog | awk '\$4 ~ /upshttpd/ { print \$1 }'\`
      [ -n "\${upshttpdpid}" ] && kill \${upshttpdpid}
      [ -x ./upsagent ] && upsagentpid=\`$ps_prog | awk '\$4 ~ /upsagent/ { print \$1 }'\`
      [ -n "\${upsmanpid}" ] && ./upsman -s
      [ -n "\${upsagentpid}" ] && kill \${upsagentpid}
      killproc -TERM \$UPSMAN_BIN
      ;;
   restart)
	   \$0 stop
	   \$0 start
	   rc_status
      ;;
   status)
      echo -n "Checking UPSMAN status..."
      checkproc \$UPSMAN_BIN
      rc_status -v 
      ;;
   *)
	echo "Usage: \$0 {start|stop|status|restart}"
	exit 1
	;;
esac
rc_exit
EOF

[ $? = 0 ] && chown root:0 $UPSMAN_STARTER && chmod 774 $UPSMAN_STARTER
[ $? = 0 ] || doerror failed to write $UPSMAN_STARTER

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# write_upsman_init()
# ------------------------------------------------------------

write_upsman_init() {

[ -z "$UPSMAN_INIT" ] && UPSMAN_INIT=upsman

if [ -f $UPSMAN_INIT ]; then
    $doecho \\nsave existing `pwd`/$UPSMAN_INIT to `pwd`/${UPSMAN_INIT}.bkp... \\c
    mv $UPSMAN_INIT ${UPSMAN_INIT}.bkp || doerror //nfailed to rename $UPSMAN_INIT
    $doecho ok!; sleep 1
fi
if [ -f ups.rc ]; then
    $doecho \\nsave obsolete `pwd`/ups.rc to `pwd`/ups.rc.bkp... \\c
    mv ups.rc ups.rc.bkp || doerror //nfailed to rename ups.rc
    $doecho ok!; sleep 1
fi
if [ -f upsm ]; then
    $doecho \\nsave obsolete `pwd`/upsm to `pwd`/upsm.bkp... \\c
    mv upsm upsm.bkp || doerror //nfailed to rename upsm
    $doecho ok!; sleep 1
fi

$doecho \\nmoving $UPS_DIR/$UPSMAN_STARTER to `pwd`/${UPSMAN_INIT}... \\c

mv $UPS_DIR/$UPSMAN_STARTER $UPSMAN_INIT
[ $? = 0 ] && chown root:0 $UPSMAN_INIT && chmod 774 $UPSMAN_INIT
[ $? = 0 ] || doerror failed to write $UPSMAN_INIT

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# write_upsman_symlinks()
# ------------------------------------------------------------
write_upsman_symlinksSuSE() {
#dodebug "create_symlinksSuSE()"

   $doecho "\\nenable upsman service... \\c"
   #/sbin/insserv -v $initdir/$UPSMAN_INIT
   /sbin/insserv $initdir/$UPSMAN_INIT
}

write_upsman_symlinks() {
#dodebug "write_symlinks()"

for i in `ls -d rc?.d 2>/dev/null`; do
    if [ -d $i ]; then
    cd $i
    for j in `ls [KS]*[0-9]upsman 2>/dev/null` `ls [KS]*[0-9]ups.rc 2>/dev/null`; do
	$doecho \\nremove old symlink `pwd`/$j... \\c
	rm $j || doerror failed to remove $j
	$doecho ok!; sleep 1
    done
    cd ..
    fi
done

for i in $startdirs; do
    if [ -d $i ]; then
	cd $i
	$doecho "\\ncreate link `pwd`/${startlink}upsman -> $initdir/$UPSMAN_INIT... \\c"
        ln -s $initdir/$UPSMAN_INIT ${startlink}upsman \
	|| doerror failed to create ${startlink}upsman
        $doecho ok!; sleep 1
	cd ..
    fi
done

for i in $killdirs; do
    if [ -d $i ]; then
	cd $i
	$doecho "\\ncreate link `pwd`/${killlink}upsman -> $initdir/$UPSMAN_INIT... \\c"
	ln -s $initdir/$UPSMAN_INIT ${killlink}upsman \
	|| doerror failed to create ${killlink}upsman
        $doecho ok!; sleep 1
	cd ..
    fi
done
}

# ------------------------------------------------------------
# write_startupsman_link()
# ------------------------------------------------------------

write_startupsman_link(){

if [ -f $UPSMAN_STARTER ]; then
    $doecho \\nsave existing `pwd`/$UPSMAN_STARTER to `pwd`/${UPSMAN_STARTER}.bkp... \\c
    mv $UPSMAN_STARTER ${UPSMAN_STARTER}.bkp || doerror \\nfailed to rename $UPSMAN_STARTER
    $doecho ok!; sleep 1
fi

$doecho "\\ncreate link `pwd`/${UPSMAN_STARTER} -> $initdir/$UPSMAN_INIT... \\c"
ln -s $initdir/$UPSMAN_INIT $UPSMAN_STARTER \
|| doerror failed to create $UPSMAN_STARTER

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# write_upsman_inittab() # only AIX
# ------------------------------------------------------------

write_upsman_inittab() {

$doecho \\nDo you want to start upsman automatically on system boot [Y/n]?: \\c
read yesno

if [ "$yesno" != "" ] && [ $yesno != y ] && [ $yesno != Y ]; then
    return 0
fi

RC2ENTRY_OLD="upsman:2:once:/usr/ups/startupsman >/dev/console 2>&1   # default entry for upsman"
RC2ENTRY="upsman:2:once:`pwd`/startupsman start>/dev/console 2>&1   # default entry for upsman"
RC0ENTRY="/usr/ups/upsman -s   # default entry for upsman"

STATE=`lsitab "upsman"`

if [ -z "$STATE" ]; then
    $doecho "making default entry in /etc/inittab"
    mkitab "$RC2ENTRY" || doerror failed to write to /etc/inittab
elif [ "$STATE" = "$RC2ENTRY_OLD" ]; then
    $doecho "changing old entry in /etc/inittab"
    chitab "$RC2ENTRY" || doerror failed to write to /etc/inittab
elif [ "$STATE" = "$RC2ENTRY" ]; then
    $doecho "using default entry in /etc/inittab"
else
    $doecho "omitting custom entry in /etc/inittab"
fi

if [ ! -x /etc/rc.shutdown ]
then
    $doecho '#!/bin/sh' > /etc/rc.shutdown
    $doecho "" >> /etc/rc.shutdown
    chmod 744 /etc/rc.shutdown
fi

STATE=`grep upsman /etc/rc.shutdown`
if [ -z "$STATE" ]
then
    $doecho "making default entry in /etc/rc.shutdown"
    $doecho "$RC0ENTRY" >> /etc/rc.shutdown || doerror failed to write to /etc/rc.shutdown
elif [ "$STATE" = "$RC0ENTRY" ]
then
    $doecho "using default entry in /etc/rc.shutdown"
else
    $doecho "omitting custom entry in /etc/rc.shutdown"
fi
}

# ------------------------------------------------------------
# write_mac_startup_upsman() # mac only
# ------------------------------------------------------------

write_mac_startup_upsman() {

MACINITDIR=/System/Library/StartupItems
MACUPSMANINITDIR=$MACINITDIR/Upsman
MACUPSMANINITSCRIPT=$MACUPSMANINITDIR/upsman
MACUPSMANINITPARAMS=$MACUPSMANINITDIR/StartupParameters.plist

$doecho \\nDo you want to start UPS daemon automatically on system boot [Y/n]?: \\c
read yesno

if [ "$yesno" != "" ] && [ $yesno != y ] && [ $yesno != Y ]; then
    return 0
fi

[ -d $MACINITDIR ] || doerror could not find $MACINITDIR, no such directory!

if [ ! -d $MACUPSMANINITDIR ]; then
    $doecho \\ncreating subdir $MACUPSMANINITDIR... \\c
    mkdir $MACUPSMANINITDIR || doerror //n could not create $MACUPSMANINITDIR
    $doecho ok!; sleep 1
fi

$doecho \\nwriting init script $MACUPSMANINITSCRIPT... \\c

cat > $MACUPSMANINITSCRIPT<<EOF
#!/bin/sh

. /etc/rc.common

##
# launch upsman listener
##

if [ -x $UPS_DIR/$UPSMAN_STARTER ]; then

    $UPS_DIR/$UPSMAN_STARTER start
fi
EOF

[ $? = 0 ] && chown root:0 $MACUPSMANINITSCRIPT && chmod 774 $MACUPSMANINITSCRIPT
[ $? = 0 ] || doerror failed to write $MACUPSMANINITSCRIPT

$doecho ok!; sleep 1

$doecho \\nwriting init script $MACUPSMANINITPARAMS... \\c

cat > $MACUPSMANINITPARAMS<<EOF
{
  Description     = "UPS controler daemon";
  Provides        = ("Upsman");
  OrderPreference = "None";
  Messages =
  {
    start = "Starting upsman UPS daemon";
    stop  = "Stopping upsman UPS daemon";
  };
}
EOF

[ $? = 0 ] && chown root:0 $MACUPSMANINITPARAMS && chmod 664 $MACUPSMANINITPARAMS
[ $? = 0 ] || doerror failed to write $MACUPSMANINITPARAMS

$doecho ok!; sleep 1
}

# ------------------------------------------------------------
# InstallUpsman()
# ------------------------------------------------------------

InstallUpsman()
{

[ -z "$UPSMAN_INIT" ] && UPSMAN_INIT=upsman
[ -z "$UPSMAN_STARTER" ] && UPSMAN_STARTER=startupsman

ask_for_readme

$doecho \\nInstall Upsman for $OPSYS to $UPS_DIR [Y/n]?: \\c
read yesno

if [ "$yesno" != "" ] && [ $yesno != y ] && [ $yesno != Y ]; then
    sleep 1
    #doexit \\nInstallation aborted!
    return 0
fi

check_ups_dir

cd ${UPS_DIR}

do_upsman_inst

#do_upsexe_inst

WriteShutdownCommand

WriteMessageCommand

WriteMailCommand

WriteAlarmCommand

if [ X${OPSYS_TYPE} = XSUSE_LINUX ]; then
	 WriteStartupsmanSuSE
else
	 WriteStartupsman
fi

do_messages_inst

do_upstyp_inst

$doecho \\nDo you want to configure upsman now  [Y/n]?: \\c
read yesno

if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
    ./ups_conf
else
    $doecho \\nYou must configure upsman before use.
    $doecho \\nTo configure upsman please enter: \"cd `pwd`\; ./ups_conf\"
fi

sleep 1

#if [ ${OPSYS} = [Bb][Ss][Dd]* ]; then
case $OPSYS in
#if [ $OPSYS = BSD_X86 -o $OPSYS = bsd_x86 ]; then
    [Bb][Ss][Dd]*)
	$doecho \\nTo start upsman automatically at system boot add the command
	$doecho \"`pwd`/$UPSMAN_STARTER start\" to your /etc/rc bootscript
	sleep 1
	$doecho \\nTo stop upsman automatically at system shutdown add the command
	$doecho \"`pwd`/$UPSMAN_STARTER stop\" to your /etc/rc.shutdown script
	sleep 1
    ;;
#elif [ ${OPSYS} = [Ii][Bb][Mm][Aa][Ii][Xx]* ]; then
    [Ii][Bb][Mm][Aa][Ii][Xx]*)
#elif [ $OPSYS = IBMAIX43 -o $OPSYS = ibmaix43 ]; then
	write_upsman_inittab
    ;;
    [Mm][Aa][Cc][Ii][Nn][Tt][Oo][Ss][Hh])
#elif [ $OPSYS = MACINTOSH -o $OPSYS = macintosh ]; then
	write_mac_startup_upsman
    ;;
    *)
#else
    [ -z "$initdir" ] && find_initdir
    dodebug "initdir = >$initdir<"
    [ -z "$rc_parent" ] && find_rcparent
    dodebug "rc_parent= >$rc_parent<"

    if [ -d $initdir -a -d $rc_parent ]; then
	$doecho \\nDo you want to start upsman automatically on system boot [Y/n]?: \\c
	read yesno
	if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
	    sleep 1
	    savedir=`pwd`
	    cd $initdir
	    write_upsman_init
	    cd $rc_parent
       if [ X${OPSYS_TYPE} = XSUSE_LINUX ]; then
		    write_upsman_symlinksSuSE
       else
	       write_upsman_symlinks
       fi
	    cd $savedir
	    write_startupsman_link
	fi
    fi
    ;;
esac
#fi

$doecho \\n\\nUPS Management Software installed in directory `pwd`; sleep 1
}

# ------------------------------------------------------------
# StartUpsman()
# ------------------------------------------------------------

StartUpsman() {

$doecho \\nDo you want to start upsman now [Y/n]?: \\c
read yesno
if [ "$yesno" = "" ] || [ $yesno = y ] || [ $yesno = Y ]; then
    $doecho; ./startupsman stop
    $doecho; ./startupsman start
else
    $doecho \\nTo start upsman manually enter: \"`pwd`/startupsman start\"
fi

sleep 1
}
